/* Next Generation Common API
   Copyright  2003-2004 by Next Generation.

   Permission is hereby granted, free of charge, to any person
   obtaining a copy of this software and associated documentation files
   (the "Software"), to deal in the Software without restriction,
   including without limitation the rights to use, copy, modify, merge,
   publish, distribute, sublicense, and/or sell copies of the Software,
   and to permit persons to whom the Software is furnished to do so,
   subject to the following conditions:

   The above copyright notice and this permission notice shall be
   included in all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
   BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
   ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
   SOFTWARE.
   
   ---

   Please send comments, bugreports and patches to <chris@ngweb.biz>.
   Visit this website for more information: http://www.ngweb.biz/
 */

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "iofunc.h"

BOOL
#ifdef UNICODE
SetRegistryValueW
#else
SetRegistryValueA
#endif /* UNICODE */
(HKEY hKey, LPCTSTR lpSubKey, LPCTSTR lpValueName, LPVOID lpValue, DWORD dwSize, int nType)
{
  BOOL bSuccess = TRUE;
  DWORD dwDummy;
  DWORD dwValue = nType == SRVT_DWORD ? (DWORD) lpValue : 0;
  HKEY hkey;

  RegCreateKeyEx (hKey, lpSubKey, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkey, &dwDummy);
  
  switch (nType)
    {
    case SRVT_DWORD:
      if (RegSetValueEx (hkey, lpValueName, 0, REG_DWORD, (CONST BYTE *) &dwValue, sizeof (DWORD)) != ERROR_SUCCESS)
        bSuccess = FALSE;
      break;
    
    case SRVT_STRING:
      if (RegSetValueEx (hkey, lpValueName, 0, REG_SZ, (CONST BYTE *) lpValue, dwSize * sizeof (TCHAR)) != ERROR_SUCCESS)
        bSuccess = FALSE;
      break;
    
    case SRVT_EXPAND:
      if (RegSetValueEx (hkey, lpValueName, 0, REG_EXPAND_SZ, (CONST BYTE *) lpValue, dwSize * sizeof (TCHAR)) != ERROR_SUCCESS)
        bSuccess = FALSE;
      break;
    }
  
  RegCloseKey (hkey);
  
  return bSuccess;
}
