/* Command Prompt Here
   Copyright  2002 by Next Generation.
   Written by Chris Hansen.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
   ---
   
   Please send comments, bugreports and patches to <chris@ngweb.biz>.
   Visit this website for more information: http://www.ngweb.biz/
 */

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <string.h>
#include <tchar.h>
#include "iofunc.h"

#define APP_NAME TEXT("Command Prompt Here")
#define CONTEXTMENU TEXT("Command Prompt &Here")
#define COMMANDLINE TEXT("\"%SystemRoot%\\system32\\cmd.exe\" /k cd /d \"%1\"")

BOOL
IsWinNT (void)
{
  return GetVersion () < 0x80000000 ? TRUE : FALSE;
}

int WINAPI
WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
  DWORD dwDefVal = 0, dwInstall;
  TCHAR sDlgTitle[80];
  
  InitCommonControls ();
  
  /* Is this platform a Windows NT version? */
  if (!IsWinNT ())
    {
      MessageBoxEx (NULL, TEXT ("\"Command Prompt Here\" can only be installed in Windows NT 4 or newer."), APP_NAME, MB_ICONERROR | MB_OK | MB_SYSTEMMODAL, MAKELANGID (LANG_ENGLISH, SUBLANG_ENGLISH_US));
      return 0;
    }
  
  /* Is "Command Prompt Here" is already installed? */
  GetRegistryValue (HKEY_LOCAL_MACHINE, TEXT ("Software\\Next Generation\\Tweak'n'Trash"), TEXT ("Command Prompt Here"), (LPVOID) &dwDefVal, &dwInstall, 0, GRVT_DWORD);
  if (!dwInstall)
    {
      _stprintf (sDlgTitle, TEXT ("Install \"%s\"?"), APP_NAME);
      if (MessageBoxEx (NULL, TEXT ("You are about to install \"Command Prompt Here\" on your computer.\nDo you want to continue?"), sDlgTitle, MB_ICONQUESTION | MB_YESNO | MB_SYSTEMMODAL, MAKELANGID (LANG_ENGLISH, SUBLANG_ENGLISH_US)) == IDYES)
        {
          SetRegistryValue (HKEY_LOCAL_MACHINE, TEXT ("Software\\Next Generation\\Tweak'n'Trash"), TEXT ("Command Prompt Here"), (LPVOID)(DWORD) 1, 0, SRVT_DWORD);
          SetRegistryValue (HKEY_CLASSES_ROOT, TEXT ("Folder\\shell\\Command Prompt Here"), NULL, (LPVOID)(LPTSTR) CONTEXTMENU, _tcslen (CONTEXTMENU), SRVT_STRING);
          SetRegistryValue (HKEY_CLASSES_ROOT, TEXT ("Folder\\shell\\Command Prompt Here\\command"), NULL, (LPVOID)(LPTSTR) COMMANDLINE, _tcslen (COMMANDLINE), SRVT_EXPAND);
          MessageBoxEx (NULL, TEXT ("\"Command Prompt Here\" is now installed on your computer.\nRun 'CmdPrompt.exe' again to uninstall \"Command Prompt Here\"."), APP_NAME, MB_ICONINFORMATION | MB_OK | MB_SYSTEMMODAL, MAKELANGID (LANG_ENGLISH, SUBLANG_ENGLISH_US));
        }
    }
  else
    {
      _stprintf (sDlgTitle, TEXT ("Uninstall \"%s\"?"), APP_NAME);
      if (MessageBoxEx (NULL, TEXT ("You are about to uninstall \"Command Prompt Here\".\nDo you want to continue?"), sDlgTitle, MB_ICONQUESTION | MB_YESNO | MB_SYSTEMMODAL, MAKELANGID (LANG_ENGLISH, SUBLANG_ENGLISH_US)) == IDYES)
        {
          SetRegistryValue (HKEY_LOCAL_MACHINE, TEXT ("Software\\Next Generation\\Tweak'n'Trash"), TEXT ("Command Prompt Here"), (LPVOID)(DWORD) 0, 0, SRVT_DWORD);
          RegDeleteKey (HKEY_CLASSES_ROOT, TEXT ("Folder\\shell\\Command Prompt Here\\command"));
          RegDeleteKey (HKEY_CLASSES_ROOT, TEXT ("Folder\\shell\\Command Prompt Here"));
          MessageBoxEx (NULL, TEXT ("\"Command Prompt Here\" is now removed from your computer."), APP_NAME, MB_ICONINFORMATION | MB_OK | MB_SYSTEMMODAL, MAKELANGID (LANG_ENGLISH, SUBLANG_ENGLISH_US));
        }
    }
  return 0;
}
