/* Next Generation Common API
   Copyright  2003-2004 by Next Generation.

   Permission is hereby granted, free of charge, to any person
   obtaining a copy of this software and associated documentation files
   (the "Software"), to deal in the Software without restriction,
   including without limitation the rights to use, copy, modify, merge,
   publish, distribute, sublicense, and/or sell copies of the Software,
   and to permit persons to whom the Software is furnished to do so,
   subject to the following conditions:

   The above copyright notice and this permission notice shall be
   included in all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
   BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
   ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
   SOFTWARE.
   
   ---

   Please send comments, bugreports and patches to <chris@ngweb.biz>.
   Visit this website for more information: http://www.ngweb.biz/
 */

#ifndef _NG_IOFUNC_H_
#define _NG_IOFUNC_H_

/* GetRegistryValue types */
#define GRVT_DWORD 1
#define GRVT_STRING 2
#define GRVT_EXPAND 3

/* SetRegistryValue types */
#define SRVT_DWORD GRVT_DWORD
#define SRVT_STRING GRVT_STRING
#define SRVT_EXPAND GRVT_EXPAND

#ifdef __cplusplus
extern "C" {
#endif

DWORD GetRegistryValueW (HKEY hKey, LPCWSTR lpSubKey, LPCWSTR lpValueName, LPVOID lpDefaultValue, LPVOID lpReturnValue, DWORD dwSize, int nType);
BOOL SetRegistryValueW (HKEY hKey, LPCWSTR lpSubKey, LPCWSTR lpValueName, LPVOID lpValue, DWORD dwSize, int nType);

#ifdef UNICODE
#define GetRegistryValue GetRegistryValueW
#define SetRegistryValue SetRegistryValueW
#else
#define GetRegistryValue GetRegistryValueA
#define SetRegistryValue SetRegistryValueA
#endif /* UNICODE */

#ifdef __cplusplus
}
#endif

#endif  /* Not _NG_IOFUNC_H_ */
